<?php

namespace Fittest\Wordpress\Admin;

class Post
{
    public function widget()
    {
        $screens = array('post', 'page');
        foreach ( $screens as $screen ) {
            add_meta_box(
                'fittest_widget_post_edit',
                __( 'Fittest', 'fittest_textdomain' ),
                array($this, 'form'),
                $screen
            );
        } 
    }
    
    public function form($post)
    {
		// Add an nonce field so we can check for it later.
		wp_nonce_field( 'myplugin_inner_custom_box', 'myplugin_inner_custom_box_nonce' );

		// Use get_post_meta to retrieve an existing value from the database.
		$value = get_post_meta( $post->ID, '_my_meta_value_key', true );

		// Display the form, using the current value.
		echo '<label for="myplugin_new_field">';
		_e( 'Description for this field', 'myplugin_textdomain' );
		echo '</label> ';
		echo '<input type="text" id="myplugin_new_field" name="myplugin_new_field"';
                echo ' value="' . esc_attr( $value ) . '" size="25" />';
    }   
}