<?php

namespace Fittest\Wordpress\Admin;

use Fittest\Experiment;
use Fittest\Variation;
use Fittest\Core;

class Shortcode
{
    private $experiment;
    
    public function __construct()
    {
        add_shortcode('fittest', array( $this, 'handleFittest'));
        add_shortcode('variation', array( $this, 'handleVariation'));
    }
    
    public function handleFittest($attributes, $content)
    {
        $id = (isset($attributes['id'])) ? $attributes['id'] : 'experiment';
        $this->experiment = Experiment::factory($id);
        do_shortcode($content);
        $fittest = Core::factory($this->experiment);
        return $fittest->choose()->getContent();
    }
    
    public function handleVariation($attributes, $content)
    {
        $content = do_shortcode($content);
        $variation = Variation::factory($content, $attributes);
        $this->experiment->addVariation($variation);
        return $content;
    }
}