<?php

namespace Fittest\Wordpress;

use Fittest\Fittest;
use Fittest\Experiment;
use Fittest\Variation\Content as Variation;

class Shortcode
{
    private $experiment;
    private $index = 0;
    
    public function __construct()
    {
        add_shortcode('fittest', array( $this, 'handleFittest'));
        add_shortcode('variation', array( $this, 'handleVariation'));
    }
    
    public function handleFittest($attributes, $content)
    {
        // set up the experiment
        $id = (isset($attributes['id'])) ? $attributes['id'] : 'experiment';
        $this->experiment = Fittest::createExperiment($id);

        // extract variatons
        do_shortcode($content);
        
        // choose variation
        return Fittest::chooseVariation($this->experiment)->get();
    }
    
    public function handleVariation($attributes, $content)
    {
        $content = do_shortcode($content);
        
        $variation = Variation::factory($this->index, array(
            'content' => $content,
            'attributes' => $attributes
        ));
        Fittest::addVariation($variation, $this->experiment);
        
        $this->index++;
        
        return $content;
    }
}