<?php

namespace Fittest\Variation;

abstract class Variation
{
    private $id;
    private $chosen = 1;
    private $awarded = 1;
    private $options = array();
    
    private function __construct($id, $options = array())
    {
        $this->id = $id;
        $this->options = $options;
    }
    
    static public function factory($id, $options = array())
    {
        return new static($id, $options);
    }
    
    abstract public function get();
    
    public function getChosen()
    {
        return $this->chosen;
    }
    
    public function setChosen($chosen)
    {
        $this->chosen = $chosen;
    }
    
    public function getAwarded()
    {
        return $this->awarded;
    }
    
    public function setAwarded($awarded)
    {
        $this->awarded = $awarded;
    }
    
    public function getId()
    {
        return $this->id;
    }
    
    public function getOptions()
    {
        return $this->options;
    }
}