<?php

namespace Mocker;

/**
 * Description of Mock
 *
 * @author rruiter
 */
class Mock
{
    protected $object;
    protected $case;

    public function __construct(\PHPUnit_Framework_TestCase $testCase)
    {
        $this->case = $testCase;

        $builder = $this->case->getMockBuilder($this->mockthis);
        $this->object = $builder->disableOriginalConstructor()->getMock();
    }
    
    public function get()
    {
        return $this->object;
    }
    
    public function returnValue($method, $value)
    {
        $this->object
            ->expects($this->case->any())
			->method($method)
			->will($this->case->returnValue($value));

        return $this;
    }
    
    public function __call($name, $arguments)
    {
        return call_user_func(array($this, 'returnValue'), $name, $arguments[0]);
    }
}
